-- Copyright 2017 Stanford University
--
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
--
--     http://www.apache.org/licenses/LICENSE-2.0
--
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.

import "regent"

task f(inner : bool) : int
  var x = 5
  do
    var x = x + 10
    if inner then
      return x
    end
  end
  return x
end

task g(n : int) : int
  var x = 1
  for x = 2, 3 do
    if n == 2 then
      return x
    end
    var x = 3
    if n == 3 then
      return x
    end
  end
  return x
end

task main()
  regentlib.assert(f(false) == 5, "test failed")
  regentlib.assert(f(true) == 15, "test failed")
  regentlib.assert(g(1) == 1, "test failed")
  regentlib.assert(g(2) == 2, "test failed")
  regentlib.assert(g(3) == 3, "test failed")
end
regentlib.start(main)
